#pragma once
class Model;
class CDP:public CDPBase
{
 public:
  CDP();
  ~CDP(void);
  void InitMCMCSteps(Model& model);
  void LoadData(Model& model);
  void LoadInits(Model& model,CDPResult& result, MTRand& mt);

  void CheckSpecialCases(Model& model, CDPResult& result);

  //  bool SimulateFromPrior(CDPResult& result, MTRand& mt);
  bool SimulateFromPrior2(CDPResult& result, MTRand& mt);
  bool clusterIterate(int clustnum,vector<int>& w1d,CDPResult& result, MTRand& mt);
  bool clusterIterate_one(CDPResult& result, MTRand& mt);
  bool iterate(CDPResult& result, MTRand& mt);

  void partition(int* W, vector<vector<int> >& w1d);
  void partition(int* K, vector<int>& w1d, vector<vector<int> >& wk2d);
  void partition(int* W, int* K, vector<vector<int> >& wk2d);
  void UpdateKJ(int* K,vector<int>& w1d, vector<int>& KJ);
  void ComponentSwap(CDPResult& result, MTRand& mt);

  // turn off/off individual sampling steps
  bool mcsamplem;
  bool mcsamplePhi;
  bool mcsamplew;
  bool mcsampleq;
  bool mcsamplealpha0;

  bool mcsamplemu;
  bool mcsampleSigma;
  bool mcsamplek;
  bool mcsamplep;
  bool mcsamplealpha;

 private:
  static bool LoadFileData(string FileName, Matrix& A, int rows, int columns);
  static bool LoadFileData(string FileName, double*** A, int rows, int columns);
  static bool LoadFileData(string FileName, double& A);
#if defined(CDP_TBB)
  static bool LoadFileData(string FileName, concurrent_vector<RowVector>& A, int rows, int columns);
  static bool LoadFileData(string FileName, concurrent_vector<SymmetricMatrix>& A, int rows, int columns);
#else
  static bool LoadFileData(string FileName, vector<RowVector>& A, int rows, int columns);
  static bool LoadFileData(string FileName, vector<SymmetricMatrix>& A, int rows, int columns);
#endif
  static bool LoadFileData(string FileName, int* A, int columns);
  static bool LoadFileData(string FileName, RowVector& A, int columns);


  void findComponentsToSwap(CDPResult& result, vector<vector<int> >& wk2d, int& j1, int& t1, int& j2, int& t2,MTRand& mt);
  double piece_1(vector<vector<int> >& wk2d,RowVector& q,RowVector& p2, int j2, RowVector& p1, int j1);
  double piece_2(RowVector& newmu, SymmetricMatrix& newSigma, UpperTriangularMatrix& newSigmaUTI, double newSigmaLogDet, RowVector& m, SymmetricMatrix& Phi, double philogdet, double nu, double gamma);
  double piece_3(RowVector& V, double alpha);
  double piece_4(double* a, double alpha, RowVector& V);

};
